diff --git a/test/unit/setup/diagnostics_test.rb b/test/unit/setup/diagnostics_test.rb
new file mode 100644
index 00000000..36e23823
--- /dev/null
+++ b/test/unit/setup/diagnostics_test.rb
@@ -0,0 +1,448 @@
+# frozen_string_literal: true
+
+require "test_helper"
+require "hive/setup/diagnostics"
+require "hive/web/app_bundle"
+require "rbconfig"
+
+class SetupDiagnosticsTest < Minitest::Test
+  include HiveTestHelper
+
+  def healthy_bins(dir)
+    FileUtils.mkdir_p(dir)
+    %w[git tmux gh claude codex node npm qmd sqlite3].each do |name|
+      path = File.join(dir, name)
+      File.write(path, "#!/bin/sh\nexit 0\n")
+      FileUtils.chmod(0o755, path)
+    end
+    dir
+  end
+
+  def build(dir, **opts)
+    bins = opts.delete(:bins) || healthy_bins(File.join(dir, "bin"))
+    which = opts.delete(:which) || ->(name) {
+      path = File.join(bins, name)
+      File.executable?(path) ? path : nil
+    }
+    versions = opts.delete(:versions) || {
+      "tmux" => "tmux 3.3a\n",
+      "gh" => "gh version 2.40.0 (2024-01-01)\n",
+      "claude" => "2.1.118 (Claude Code)\n",
+      "codex" => "codex-cli 0.1.0\n",
+      "node" => "v20.11.0\n",
+      "npm" => "10.2.4\n",
+      "git" => "git version 2.43.0\n",
+      "qmd" => "0.5.0\n",
+      "sqlite3" => "3.45.0 2024-01-01\n"
+    }
+    runner = opts.delete(:runner) || ->(argv) {
+      bin = File.basename(argv[0].to_s)
+      if argv[1] == "auth" && argv[2] == "status"
+        [ "Logged in to github.com as someone\n", "", true ]
+      else
+        [ versions[bin].to_s, "", true ]
+      end
+    }
+    agent_auth = opts.delete(:agent_auth) || ->(_name) { true }
+    gh_auth = opts.delete(:gh_auth) || -> { true }
+    app_bundle = opts.delete(:app_bundle) || Hive::Web::AppBundle.new(
+      data_home: File.join(dir, "data"),
+      env: {},
+      source_app_dir: File.join(dir, "no-source"),
+      downloader: ->(*) { raise "no net" },
+      bundler: ->(*) { raise "no bundle" }
+    )
+    # Pre-install a current managed web bundle so default health is green.
+    # The one missing-bundle case runs inside this source checkout, so disable
+    # that production fallback explicitly to exercise the bootstrappable row.
+    if opts.delete(:skip_web_seed)
+      app_bundle.define_singleton_method(:source_checkout_app_dir) { nil }
+    else
+      FileUtils.mkdir_p(File.join(app_bundle.managed_app_dir, "config"))
+      File.write(File.join(app_bundle.managed_app_dir, "config", "application.rb"), "# rails\n")
+      File.write(app_bundle.version_stamp_path, "#{Hive::VERSION}\n")
+    end
+
+    Hive::Setup::Diagnostics.new(
+      env: opts.delete(:env) || { "HOME" => dir, "PATH" => bins },
+      host_os: opts.delete(:host_os) || "linux-gnu",
+      home: dir,
+      which: which,
+      runner: runner,
+      app_bundle: app_bundle,
+      agent_auth: agent_auth,
+      gh_auth: gh_auth,
+      **opts
+    )
+  end
+
+  def test_every_healthy_dependency_is_ok
+    with_tmp_dir do |dir|
+      report = build(dir).call
+      assert report.ok, report.results.map { |r| [ r.name, r.status, r.detail ] }.inspect
+      report.results.each do |row|
+        assert_equal "ok", row.status, "#{row.name} should be ok: #{row.detail}"
+        assert_nil row.fix
+        refute row.bootstrappable
+      end
+    end
+  end
+
+  def test_missing_binary_yields_linux_remediation_without_execution
+    with_tmp_dir do |dir|
+      bins = File.join(dir, "bin")
+      FileUtils.mkdir_p(bins)
+      # Only provide npm so other missing tools are diagnosed; leave git out.
+      %w[tmux gh claude codex node npm qmd].each do |name|
+        path = File.join(bins, name)
+        File.write(path, "#!/bin/sh\n")
+        FileUtils.chmod(0o755, path)
+      end
+      executed = []
+      report = build(
+        dir,
+        bins: bins,
+        runner: ->(argv) {
+          executed << argv
+          [ "tmux 3.3a\n", "", true ]
+        }
+      ).call
+
+      git = report.results.find { |r| r.name == "git" }
+      assert_equal "missing", git.status
+      assert_match(/apt-get install -y git|package manager/, git.fix)
+      refute git.bootstrappable
+      refute report.ok
+      # Diagnostics must not run install commands — only version/auth probes.
+      refute executed.any? { |argv| argv.join(" ").include?("apt-get") }
+    end
+  end
+
+  def test_missing_binary_macos_remediation
+    with_tmp_dir do |dir|
+      report = build(
+        dir,
+        host_os: "darwin23",
+        which: ->(name) { name == "git" ? nil : File.join(dir, "bin", name) },
+        bins: healthy_bins(File.join(dir, "bin"))
+      ).call
+      # Force git missing via which override while keeping path existence for others
+      report = Hive::Setup::Diagnostics.new(
+        env: { "HOME" => dir },
+        host_os: "darwin23",
+        home: dir,
+        which: ->(name) { name == "git" ? nil : "/usr/bin/#{name}" },
+        runner: ->(argv) {
+          bin = File.basename(argv[0])
+          if argv.include?("auth")
+            [ "Logged in\n", "", true ]
+          else
+            [ "#{bin} 3.3.0\n", "", true ]
+          end
+        },
+        agent_auth: ->(*) { true },
+        gh_auth: -> { true },
+        app_bundle: Hive::Web::AppBundle.new(
+          data_home: File.join(dir, "data"),
+          env: {},
+          source_app_dir: File.join(dir, "nope"),
+          downloader: ->(*) { },
+          bundler: ->(*) { }
+        ).tap { |b|
+          FileUtils.mkdir_p(File.join(b.managed_app_dir, "config"))
+          File.write(File.join(b.managed_app_dir, "config", "application.rb"), "#\n")
+          File.write(b.version_stamp_path, "#{Hive::VERSION}\n")
+        }
+      ).call
+
+      git = report.results.find { |r| r.name == "git" }
+      assert_equal "missing", git.status
+      assert_equal "brew install git", git.fix
+    end
+  end
+
+  def test_unauthenticated_external_clis_emit_exact_login_and_are_not_bootstrappable
+    with_tmp_dir do |dir|
+      report = build(
+        dir,
+        agent_auth: ->(name) { false },
+        gh_auth: -> { false }
+      ).call
+
+      %w[gh claude codex].each do |name|
+        row = report.results.find { |r| r.name == name }
+        assert_equal "unauthenticated", row.status, name
+        refute row.bootstrappable, name
+      end
+      assert_equal "gh auth login", report.results.find { |r| r.name == "gh" }.fix
+      assert_equal "claude setup-token", report.results.find { |r| r.name == "claude" }.fix
+      assert_equal "codex login", report.results.find { |r| r.name == "codex" }.fix
+      refute report.ok
+    end
+  end
+
+  def test_api_key_authentication_avoids_false_negative
+    with_tmp_dir do |dir|
+      # Use real AgentProfiles.logged_in? path with no credential files, but
+      # ANTHROPIC_API_KEY present so claude is considered authenticated.
+      env = {
+        "HOME" => dir,
+        "PATH" => healthy_bins(File.join(dir, "bin")),
+        "ANTHROPIC_API_KEY" => "sk-test",
+        "OPENAI_API_KEY" => "sk-openai"
+      }
+      diag = Hive::Setup::Diagnostics.new(
+        env: env,
+        host_os: "linux",
+        home: dir,
+        which: ->(name) {
+          path = File.join(env["PATH"], name)
+          File.executable?(path) ? path : nil
+        },
+        runner: ->(argv) {
+          if argv[1] == "auth"
+            [ "", "not logged in", false ]
+          else
+            [ "1.0.0\n", "", true ]
+          end
+        },
+        gh_auth: -> { true },
+        app_bundle: Hive::Web::AppBundle.new(
+          data_home: File.join(dir, "data"),
+          env: {},
+          source_app_dir: File.join(dir, "nope"),
+          downloader: ->(*) { },
+          bundler: ->(*) { }
+        ).tap { |b|
+          FileUtils.mkdir_p(File.join(b.managed_app_dir, "config"))
+          File.write(File.join(b.managed_app_dir, "config", "application.rb"), "#\n")
+          File.write(b.version_stamp_path, "#{Hive::VERSION}\n")
+        }
+      )
+      report = diag.call
+      assert_equal "ok", report.results.find { |r| r.name == "claude" }.status
+      assert_equal "ok", report.results.find { |r| r.name == "codex" }.status
+    end
+  end
+
+  def test_on_disk_agent_credentials_count_as_logged_in
+    with_tmp_dir do |dir|
+      FileUtils.mkdir_p(File.join(dir, ".claude"))
+      File.write(File.join(dir, ".claude", ".credentials.json"), '{"token":"x"}')
+      FileUtils.mkdir_p(File.join(dir, ".codex"))
+      File.write(File.join(dir, ".codex", "auth.json"), '{"token":"y"}')
+
+      diag = Hive::Setup::Diagnostics.new(
+        env: { "HOME" => dir, "PATH" => healthy_bins(File.join(dir, "bin")) },
+        host_os: "linux",
+        home: dir,
+        which: ->(name) {
+          path = File.join(dir, "bin", name)
+          File.executable?(path) ? path : nil
+        },
+        runner: ->(*) { [ "1.0.0\n", "", true ] },
+        gh_auth: -> { true },
+        app_bundle: Hive::Web::AppBundle.new(
+          data_home: File.join(dir, "data"),
+          env: {},
+          source_app_dir: File.join(dir, "nope"),
+          downloader: ->(*) { },
+          bundler: ->(*) { }
+        ).tap { |b|
+          FileUtils.mkdir_p(File.join(b.managed_app_dir, "config"))
+          File.write(File.join(b.managed_app_dir, "config", "application.rb"), "#\n")
+          File.write(b.version_stamp_path, "#{Hive::VERSION}\n")
+        }
+      )
+      report = diag.call
+      assert_equal "ok", report.results.find { |r| r.name == "claude" }.status
+      assert_equal "ok", report.results.find { |r| r.name == "codex" }.status
+    end
+  end
+
+  def test_qmd_on_path_or_managed_prefix_accepted_and_absent_is_bootstrappable
+    with_tmp_dir do |dir|
+      # Managed prefix without PATH entry.
+      managed = File.join(Hive::Paths.data_home, "qmd", "bin")
+      # Use explicit data_home isolation via HIVE_HOME collapse? Paths uses XDG.
+      # Inject which that misses qmd, but file exists under data_home/qmd.
+      data = File.join(dir, "data", "hive")
+      FileUtils.mkdir_p(File.join(data, "qmd", "bin"))
+      qmd = File.join(data, "qmd", "bin", "qmd")
+      File.write(qmd, "#!/bin/sh\necho 1.0.0\n")
+      FileUtils.chmod(0o755, qmd)
+
+      with_env(
+        "HOME" => dir,
+        "HIVE_HOME" => nil,
+        "XDG_DATA_HOME" => File.join(dir, "data"),
+        "XDG_CONFIG_HOME" => File.join(dir, "config"),
+        "XDG_STATE_HOME" => File.join(dir, "state"),
+        "XDG_CACHE_HOME" => File.join(dir, "cache")
+      ) do
+        bins = healthy_bins(File.join(dir, "bin"))
+        FileUtils.rm_f(File.join(bins, "qmd"))
+        report = Hive::Setup::Diagnostics.new(
+          env: ENV.to_h.merge("HOME" => dir),
+          host_os: "linux",
+          home: dir,
+          which: ->(name) {
+            return nil if name == "qmd"
+
+            path = File.join(bins, name)
+            File.executable?(path) ? path : nil
+          },
+          runner: ->(*) { [ "1.0.0\n", "", true ] },
+          agent_auth: ->(*) { true },
+          gh_auth: -> { true },
+          app_bundle: Hive::Web::AppBundle.new(
+            data_home: File.join(dir, "data", "hive"),
+            env: {},
+            source_app_dir: File.join(dir, "nope"),
+            downloader: ->(*) { },
+            bundler: ->(*) { }
+          ).tap { |b|
+            FileUtils.mkdir_p(File.join(b.managed_app_dir, "config"))
+            File.write(File.join(b.managed_app_dir, "config", "application.rb"), "#\n")
+            File.write(b.version_stamp_path, "#{Hive::VERSION}\n")
+          }
+        ).call
+        qmd_row = report.results.find { |r| r.name == "qmd" }
+        assert_equal "ok", qmd_row.status, qmd_row.detail
+        assert_equal qmd, qmd_row.path
+      end
+    end
+
+    with_tmp_dir do |dir|
+      bins = healthy_bins(File.join(dir, "bin"))
+      FileUtils.rm_f(File.join(bins, "qmd"))
+      report = build(dir, bins: bins, skip_web_seed: true).call
+      qmd_row = report.results.find { |r| r.name == "qmd" }
+      assert_equal "bootstrappable", qmd_row.status
+      assert qmd_row.bootstrappable
+      assert_match(/npm install --global --prefix/, qmd_row.fix)
+
+      web = report.results.find { |r| r.name == "web_bundle" }
+      assert_equal "bootstrappable", web.status
+      assert web.bootstrappable
+      # qmd + web bootstrappable alone do not fail the report when other deps ok
+      assert report.ok, report.hard_failures.map(&:to_h).inspect
+    end
+  end
+
+  def test_outdated_tmux_is_reported
+    with_tmp_dir do |dir|
+      report = build(
+        dir,
+        versions: {
+          "tmux" => "tmux 2.9\n",
+          "gh" => "gh version 2.40.0\n",
+          "claude" => "2.1.118\n",
+          "codex" => "0.1.0\n",
+          "node" => "v20.0.0\n",
+          "npm" => "10.0.0\n",
+          "git" => "git version 2.40.0\n",
+          "qmd" => "0.5.0\n"
+        }
+      ).call
+      tmux = report.results.find { |r| r.name == "tmux" }
+      assert_equal "outdated", tmux.status
+      assert_match(/below minimum/, tmux.detail)
+      refute report.ok
+    end
+  end
+
+  def test_timeout_and_spawn_errors_degrade_without_hang
+    with_tmp_dir do |dir|
+      report = build(
+        dir,
+        runner: ->(_argv) { raise Timeout::Error, "timed out" }
+      ).call
+      # Version probes fail soft; binaries still found so status stays ok with nil version
+      # or error for parse failures. gh auth will fail → unauthenticated.
+      gh = report.results.find { |r| r.name == "gh" }
+      assert_includes %w[unauthenticated error ok], gh.status
+      # Must return a complete matrix either way.
+      assert_equal 11, report.results.length
+    end
+  end
+
+  def test_default_probe_timeout_kills_descendants_before_returning
+    with_tmp_dir do |dir|
+      child_pid_path = File.join(dir, "child.pid")
+      script = <<~RUBY
+        child = spawn(#{RbConfig.ruby.inspect}, "-e", "sleep 30")
+        File.write(#{child_pid_path.inspect}, child)
+        sleep 30
+      RUBY
+      diagnostics = Hive::Setup::Diagnostics.new(
+        env: { "HOME" => dir, "PATH" => ENV.fetch("PATH", "") },
+        probe_timeout: 1.0
+      )
+
+      out, err, ok = diagnostics.send(:default_runner, [ RbConfig.ruby, "-e", script ])
+
+      assert_equal "", out
+      assert_equal "", err
+      refute ok
+      child_pid = Integer(File.read(child_pid_path))
+      refute process_alive?(child_pid), "probe timeout must not leave a prerequisite child running"
+    end
+  end
+
+  def test_invalid_result_status_raises
+    assert_raises(ArgumentError) do
+      Hive::Setup::Diagnostics::Result.new(
+        name: "x", status: "nope", detail: "d", fix: nil, bootstrappable: false
+      )
+    end
+  end
+
+  def test_unsupported_host_still_emits_install_guidance
+    with_tmp_dir do |dir|
+      report = build(dir, host_os: "mingw32", skip_web_seed: false).call
+      git = report.results.find { |r| r.name == "git" }
+      # git is present via healthy bins — platform only affects missing fixes.
+      # Force missing:
+      report = Hive::Setup::Diagnostics.new(
+        env: { "HOME" => dir },
+        host_os: "mingw32",
+        home: dir,
+        which: ->(*) { nil },
+        runner: ->(*) { [ "", "", false ] },
+        agent_auth: ->(*) { false },
+        gh_auth: -> { false },
+        app_bundle: Hive::Web::AppBundle.new(
+          data_home: File.join(dir, "data"),
+          env: {},
+          source_app_dir: File.join(dir, "nope"),
+          downloader: ->(*) { },
+          bundler: ->(*) { }
+        )
+      ).call
+      git = report.results.find { |r| r.name == "git" }
+      assert_equal "missing", git.status
+      assert_match(/Linux\/macOS supported/, git.fix)
+    end
+  end
+
+  def test_report_to_h_is_json_serializable
+    with_tmp_dir do |dir|
+      report = build(dir).call
+      json = JSON.generate(report.to_h)
+      parsed = JSON.parse(json)
+      assert_equal "hive-setup-diagnostics", parsed["schema"]
+      assert_equal 11, parsed["results"].length
+      assert parsed["ok"]
+    end
+  end
+
+  private
+
+  def process_alive?(pid)
+    Process.kill(0, pid)
+    true
+  rescue Errno::ESRCH
+    false
+  end
+end
